	addHook("PlayerThink", function(player)
		for player in players.iterate
			if not (gametype == GT_SCLASH or gametype == GT_TSCLASH)
			return end
				if (player.spectator)
				return end
					if not (player and player.mo.valid) then
					return end
						if (player.mo.skin == "sonic" or player.mo.skin == "metalsonic" or player.mo.skin == "supersonic")
						and (player.mo.state == S_PLAY_SPRING and player.cmd.buttons == BT_USE)
						player.mo.state = S_PLAY_ROLL
						player.pflags = PF_JUMPED
						P_SpawnThokMobj(player)
						P_SpawnGhostMobj(player.mo)
						S_StartSound(player.mo, sfx_s1a2, player)
					end
			end
	end)


	addHook("PlayerThink", function(player)
		for player in players.iterate
			if not (gametype == GT_SCLASH or gametype == GT_TSCLASH)
			return end
				if (player.spectator)
				return end
					if not (player and player.mo.valid) then
					return end
						if (player.mo.skin == "tails" and player.mo.state == S_PLAY_FLY and player.cmd.buttons == BT_USE and player.powers[pw_super])
						and not (player.weapondelay)
						P_SpawnGhostMobj(player.mo)
						P_InstaThrust(player.mo, player.mo.angle, FRACUNIT*40)
						player.weapondelay = 3*TICRATE
					end
			end
	end)
	
	addHook("PlayerThink", function(player)
		for player in players.iterate
			if not (gametype == GT_SCLASH or gametype == GT_TSCLASH)
			return end
				if (player.spectator)
					return end
					if not (player and player.mo.valid) then
					return end
						if (player.mo.skin == "knuckles" and player.mo.state == S_PLAY_GLIDE_LANDING and player.cmd.buttons == BT_USE)
						P_SetObjectMomZ(player.mo, 10*FRACUNIT)
						P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT)
						S_StartSound(player.mo, sfx_s3k81, player)
						player.mo.state = S_PLAY_ROLL
					end
			end
	end)



	addHook("PlayerThink", function(player)
		for player in players.iterate	
			if (player.spectator) return end
				if (player and player.mo.valid) then
					if (gametype == GT_SCLASH or gametype == GT_TSCLASH)
						if (player.mo.skin == "knuckles" and player.mo.state == S_PLAY_GLIDE_LANDING and player.cmd.buttons == BT_JUMP)
						P_SetObjectMomZ(player.mo, 30*FRACUNIT)
						P_Thrust(player.mo, player.mo.angle, -4*FRACUNIT)
						S_StartSound(player.mo, sfx_belnch)
						player.mo.state = S_PLAY_SPRING
						player.powers[pw_nocontrol] = 1*TICRATE
					end
				end
			end
		end
	end)	

	addHook("PlayerThink", function(player)
		for player in players.iterate
			if not (gametype == GT_SCLASH or gametype == GT_TSCLASH)
			return end
				if (player.spectator)
				return end
					if not (player and player.mo.valid) then
					return end
						if (player.mo.skin == "amy" and player.powers[pw_super] and player.cmd.buttons == BT_USE and player.mo.state == S_PLAY_MELEE_LANDING and P_IsObjectOnGround(player.mo) and not player.weapondelay)
						player.mo.state = S_PLAY_ROLL
						P_SetObjectMomZ(player.mo, 25*FRACUNIT)
						P_InstaThrust(player.mo, player.mo.angle, 10*FRACUNIT)
						S_StartSound(player.mo, sfx_sprong)
						player.weapondelay = 1*TICRATE
						player.pflags = PF_JUMPED
					end
			end
	end)
	
	addHook("PlayerThink", function(player)
		for player in players.iterate
			if (player.spectator) return end
				if (player and player.mo.valid) then	
					if (gametype == GT_SCLASH or gametype == GT_TSCLASH)
						if (player.mo.skin == "amy" and player.cmd.buttons == BT_CUSTOM1 and player.powers[pw_super] and player.mo.state == S_PLAY_TWINSPIN)
						and not (player.weapondelay)
						P_SetObjectMomZ(player.mo, -25*FRACUNIT)
						S_StartSound(player.mo, sfx_zoom)
						player.mo.state = S_PLAY_MELEE
						player.weapondelay = 1*TICRATE
					end
				end
			end
		end
	end)

	addHook("PlayerThink", function(player)
		for player in players.iterate
			if (player.spectator) return end
				if (player and player.mo.valid)
					if (gametype == GT_SCLASH or gametype == GT_TSCLASH)
						if (player.mo.skin == "amy" and player.powers[pw_super])
						and not (player.mo.state == S_PLAY_TWINSPIN)
						player.pflags = $ & ~PF_THOKKED
					end
				end
			end
		end
	end)
	
	//skipped fang and metal since I didn't have any ideas.